import processing.pdf.*;
import java.util.Calendar;
import java.util.List;

class DropNode {

  float x;
  float y;
  float r;
  
  float vx = 0;
  float vy = 1;
  
  float red = 30;
  float green = random(40);
  float blue = 160 + random(80);
  
  int life = 1;
  boolean falling = true;
  
  DropNode(float x, float y, float r) {
    this.x = x;
    this.y = y;
    this.r = r + random(10);
    
    if (this.r < 6) {
      falling = true;
    }

  }
  
  void draw() {
    green += 1;
    fill(red, green, blue);
    stroke(red, green, blue);
    ellipse(x, y, r*2, r*2);
  }
  
}

boolean savePDF = false;

int maxCount = 5000; //max count of the cirlces
int currentCount = 1;
List<DropNode> dropNodes = new ArrayList<DropNode>();

void setup() {
  size(1000, 1000);
  smooth();
  frameRate(1000);
  background(0);
}


void draw() {
  if (savePDF) beginRecord(PDF, timestamp()+".pdf");
  //background(206, 225, 255);

  strokeWeight(0.5);
  //noFill();


  dropNodes.add(new DropNode(random(0, width), 0, 4));

  for (int i = dropNodes.size() - 1; i >= 0; --i) {
    DropNode dp = dropNodes.get(i);
    float dx =dp.x - width/2;
    float dy =dp.y - height/2;
    if ((dx*dx+dy*dy) < 200*200) {
      dp.vy = -dp.vy / 2;
      dp.vx += dp.x >= width/2 ? 1 : -1;
    }
    
    dp.y += dp.vy;
    dp.x += dp.vx;
    
    dp.vy += 0.03;
    
    if (height < dp.y) {
      dropNodes.remove(i);
    }
    
    dp.draw();
  }

  //dropNodes.removeIf(dp -> dp.y > height);

  if (savePDF) {
    savePDF = false;
    endRecord();
  }
}

void keyReleased() {
  if (key == 's' || key == 'S') saveFrame(timestamp()+"_##.png");
  if (key == 'p' || key == 'P') savePDF = true;
}

// timestamp
String timestamp() {
  Calendar now = Calendar.getInstance();
  return String.format("%1$ty%1$tm%1$td_%1$tH%1$tM%1$tS", now);
}